<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.18                                                  |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2016 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Patch #5                                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Acquire
 * @copyright (C) 2002-2016 Esselbach Internet Solutions
 */

/**
 * class acquire
 * A class that contains routines to import data from a Miraserver database
 * @author Philipp Louis Esselbach
 * @package Contentteller
 */

class acquire
{

/**
 * function dbconnect
 * A function to connect to a Miraserver MySQL database
 * @author Philipp Louis Esselbach
 */

	function dbconnect()
    {
        global $preferences, $words_acquire;

        $error = "";

        $import_db_link = @mysqli_connect($preferences['acquire_db_hostname'], $preferences['acquire_db_username'], $preferences['acquire_db_password'], $preferences['acquire_db_name']) or $error = $words_acquire['FATAL_CAN_NOT_CONNECT_SERVER'];

        return $error;
    }

/**
 * function dbclose
 * A function to close the connection to the Miraserver MySQL database
 * @author Philipp Louis Esselbach
 */

    function dbclose()
    {
    	global $import_db_link;

        mysqli_close($import_db_link);
    }

/**
 * function users
 * A function to get the the number of user accounts from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function users()
    {
    	global $import_db_link, $preferences;
    	$query = mysqli_query($import_db_link,"SELECT COUNT(userid) FROM ".$preferences['acquire_db_prefix']."members");
    	list($users) = mysqli_fetch_row($query);

    	return $users;
    }

/**
 * function usersimport
 * A function to import user accounts from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function usersimport($start, $users)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."members LIMIT ".intval($start).", ".intval($users));
    	if (mysqli_num_rows($query))
    	{
    		$users = array();
    		while($usersarray = mysqli_fetch_array($query))
    		{
    			$users_dat = array();
    			$users_dat['user_id'] = $usersarray['userid'];
    			$users_dat['user_loginname'] = $usersarray['username'];
    			$users_dat['user_name'] = $usersarray['username'];
    			$users_dat['user_password'] = $usersarray['password'];
    			$users_dat['user_posts'] = $usersarray['numposts'];
    			$users_dat['user_birthday'] = "";
    			$users_dat['user_homepage'] = "";
    			$users_dat['user_email'] = $usersarray['email'];
    			$users_dat['user_regemail'] = $usersarray['email'];
    			$users_dat['user_icq'] = "";
    			$users_dat['user_aim'] = "";
    			$users_dat['user_yam'] = "";
    			$users_dat['user_ms'] = "";
    			$users_dat['user_jabber'] = "";
    			$users_dat['user_occupation'] = "";
    			$users_dat['user_interests'] = "";
    			$users_dat['user_picture'] = "";
    			$users_dat['user_signature'] = "";
    			$users_dat['user_cconfig'] = "";
    			$users_dat['user_banned'] = "";
    			$users_dat['user_bannedreason'] = "";
    			$users_dat['user_securekey'] = "";
    			$users_dat['user_regip'] = "::1";
    			$users_dat['user_editip'] = "::1";
    			$users[] = $users_dat;
    		}
    	}
    	else
    	{
    		$users = 0;
    	}

    	return $users;
    }

/**
 * function content
 * A function to get the the number of content pages from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function content()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."sections WHERE cat_status = '0'");
    	list($pages) = mysqli_fetch_row($query);

    	return $pages;
    }

/**
 * function contentpagesimport
 * A function to import content pages from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function contentpagesimport($start, $pages)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."sections WHERE cat_status = '0' LIMIT ".intval($start).", ".intval($pages));

    	if (mysqli_num_rows($query))
    	{
    		$contentpages = array();
    		while($contentpagesarray = mysqli_fetch_array($query))
    		{
    			$contentpages_dat = array();
    			$contentpages_dat['page_id'] = $contentpagesarray['id'];
    			$contentpages_dat['page_website'] = 0;
    			$contentpages_dat['page_title'] = stripslashes($contentpagesarray['name']);
    			$contentpages_dat['page_text'] = stripslashes($contentpagesarray['content']);

    			preg_match_all("/\"http:\/\/(.*){imgdir}\?image=(.*)\"|\"{imgdir}\?image=(.*)\"/Ui", $newsstories_dat['page_text'], $matches, PREG_SET_ORDER);
    			foreach( $matches as $match )
    			{
    				$this_match = ( isset( $match[3] ) ) ? $match[3] : $match[2] ;
    				$query2 = mysqli_query($import_db_link, "SELECT filename, path FROM ".$preferences['acquire_db_prefix']."images WHERE id = '" . intval( $this_match ) ."'" );
    				while( list( $image_filename, $image_path ) = mysqli_fetch_row( $query2 ) )
    				{
    					$this_image = ( $image_path ) ? "miraserver/images/" . $image_path . $image_filename : "miraserver/images/" . $image_filename ;

    					if( isset( $match[3] ) )
    					{
    						$newsstories_dat['page_text'] = str_replace( "{imgdir}?image=" . $match[3], $this_image, $newsstories_dat['page_text'] );
    					}
    					else
    					{
    						$newsstories_dat['page_text'] = str_replace( "http://" . $match[1] . "{imgdir}?image=" . $match[2], $this_image, $newsstories_dat['page_text'] );
    					}
    				}
    			}

    			$contentpages_dat['page_html'] = 1;
    			$contentpages_dat['page_icon'] = 0;
    			$contentpages_dat['page_code'] = 0;
    			$contentpages_dat['page_postip'] = "::1";
    			$contentpages_dat['page_editip'] = "::1";
    			$contentpages[] = $contentpages_dat;
    		}
    	}
    	else
    	{
    		$contentpages = 0;
    	}

    	return $contentpages;
    }

/**
 * function newscategories
 * A function to get the the number of news categories from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function newscategories()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."news_categories");
    	list($newscategories) = mysqli_fetch_row($query);

    	return $newscategories;
    }

/**
 * function newscategoriesimport
 * A function to import news categories from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function newscategoriesimport()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."news_categories");
    	if (mysqli_num_rows($query))
    	{
    		$newscategories = array();
    		while($newscategoriesarray = mysqli_fetch_array($query))
    		{
    			$newscategories_dat = array();
    			$newscategories_dat['category_id'] = $newscategoriesarray['id'];
    			$newscategories_dat['category_name'] = stripslashes($newscategoriesarray['name']);
    			$newscategories_dat['category_desc'] = "";
    			$newscategories_dat['category_parent'] = "";
    			$newscategories_dat['category_permissions'] = "";
    			$newscategories_dat['category_postip'] = "::1";
    			$newscategories_dat['category_editip'] = "::1";
    			$newscategories[] = $newscategories_dat;
    		}
    	}
    	else
    	{
    		$newscategories = 0;
    	}

    	return $newscategories;
    }

/**
 * function newsstories
 * A function to get the the number of news stories from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function newsstories()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."news");
    	list($newsstories) = mysqli_fetch_row($query);

    	return $newsstories;
    }

/**
 * function newsstoriesimport
 * A function to import news stories from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function newsstoriesimport($start, $stories)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."news LIMIT ".intval($start).", ".intval($stories));

    	if (mysqli_num_rows($query))
    	{
    		$newsstories = array();
    		while($newsstoriesarray = mysqli_fetch_array($query))
    		{
    			$newsstories_dat = array();
    			$newsstories_dat['story_id'] = $newsstoriesarray['id'];
    			$newsstories_dat['story_website'] = 0;
    			$newsstories_dat['story_category'] = $newsstoriesarray['category'];

				$query2 = mysqli_query($import_db_link, "SELECT name FROM ".$preferences['acquire_db_prefix']."authors WHERE authorid = '" . intval( $newsstoriesarray[ 'author'] ) . "'");
				list($authorname) = mysqli_fetch_row($query2);
				$newsstories_dat['story_author'] = $authorname;

    			$newsstories_dat['story_title'] = stripslashes($newsstoriesarray['subject']);
    			$newsstories_dat['story_text'] = stripslashes($newsstoriesarray['text']);

    			preg_match_all("/\"http:\/\/(.*){imgdir}\?image=(.*)\"|\"{imgdir}\?image=(.*)\"/Ui", $newsstories_dat['story_text'], $matches, PREG_SET_ORDER);
    			foreach( $matches as $match )
    			{
    				$this_match = ( isset( $match[3] ) ) ? $match[3] : $match[2] ;
    				$query2 = mysqli_query($import_db_link, "SELECT filename, path FROM ".$preferences['acquire_db_prefix']."images WHERE id = '" . intval( $this_match ) ."'" );
    				while( list( $image_filename, $image_path ) = mysqli_fetch_row( $query2 ) )
    				{
    					$this_image = ( $image_path ) ? "miraserver/images/" . $image_path . $image_filename : "miraserver/images/" . $image_filename ;

    					if( isset( $match[3] ) )
    					{
    						$newsstories_dat['story_text'] = str_replace( "{imgdir}?image=" . $match[3], $this_image, $newsstories_dat['story_text'] );
    					}
    					else
    					{
    						$newsstories_dat['story_text'] = str_replace( "http://" . $match[1] . "{imgdir}?image=" . $match[2], $this_image, $newsstories_dat['story_text'] );
    					}
    				}
    			}

    			$newsstories_dat['story_extendedtext'] = "";
    			$newsstories_dat['story_main'] = 1;
    			$newsstories_dat['story_time'] = date("Y-m-d H:i:s", $newsstoriesarray['datetime']);

    			$query2 = mysqli_query($import_db_link,"SELECT postid FROM ".$preferences['acquire_db_prefix']."posts WHERE contentid = '".intval($newsstoriesarray['id'])."' AND type='news'");
    			list($comments) = mysqli_num_rows($query2);

    			$newsstories_dat['story_comments'] = $comments;
    			$newsstories_dat['story_source'] = $newsstoriesarray['membername'];
    			$newsstories_dat['story_teaser'] = "";
    			$newsstories_dat['story_extra1'] = "";
    			$newsstories_dat['story_extra2'] = "";
    			$newsstories_dat['story_extra3'] = "";
    			$newsstories_dat['story_extra4'] = "";
    			$newsstories_dat['story_extra5'] = "";
    			$newsstories_dat['story_extra6'] = "";
    			$newsstories_dat['story_extra7'] = "";
    			$newsstories_dat['story_extra8'] = "";
    			$newsstories_dat['story_extra9'] = "";
    			$newsstories_dat['story_extra10'] = "";
    			$newsstories_dat['story_extra11'] = "";
    			$newsstories_dat['story_extra12'] = "";
    			$newsstories_dat['story_extra13'] = "";
    			$newsstories_dat['story_extra14'] = "";
    			$newsstories_dat['story_extra15'] = "";
    			$newsstories_dat['story_extra16'] = "";
    			$newsstories_dat['story_extra17'] = "";
    			$newsstories_dat['story_extra18'] = "";
    			$newsstories_dat['story_extra19'] = "";
    			$newsstories_dat['story_extra20'] = "";
    			$newsstories_dat['story_html'] = 1;
    			$newsstories_dat['story_icon'] = 0;
    			$newsstories_dat['story_code'] = 0;
    			$newsstories_dat['story_postip'] = "::1";
    			$newsstories_dat['story_editip'] = "::1";
    			$newsstories_dat['story_editreason'] = "";
    			$newsstories_dat['story_hook'] = "0";
    			$newsstories_dat['story_sticky'] = "0";
    			$newsstories_dat['story_comm'] = "0";
    			$newsstories_dat['story_link'] = ( preg_match( "/http:\/\//i", $newsstoriesarray['link'] ) ) ? stripslashes($newsstoriesarray['link']) : "" ;
    			$newsstories[] = $newsstories_dat;
    		}
    	}
    	else
    	{
    		$newsstories = 0;
    	}

    	return $newsstories;
    }

/**
 * function newsattachments
 * Dummy function to return zero news attachments
 * @author Philipp Louis Esselbach
 */
    function newsattachments()
    {
    	return 0;
    }

/**
 * function newscomments
 * A function to get the the number of news comments from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function newscomments()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."posts WHERE type='news'");
    	list($newscomments) = mysqli_fetch_row($query);

    	return $newscomments;
    }

/**
 * function newscommentsimport
 * A function to import news comments from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function newscommentsimport($start, $comments)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."posts WHERE type='news' LIMIT ".intval($start).", ".intval($comments));
    	if (mysqli_num_rows($query))
    	{
    		$newscomments = array();
    		while($newscommentsarray = mysqli_fetch_array($query))
    		{
    			$newscomments_dat = array();
    			$newscomments_dat['comment_id'] = $newscommentsarray['postid'];
    			$newscomments_dat['comment_website'] = 0;
    			$newscomments_dat['comment_category'] = 1;
    			$newscomments_dat['comment_author'] = $newscommentsarray['username'];
    			$newscomments_dat['comment_story'] = $newscommentsarray['contentid'];
    			$newscomments_dat['comment_icon'] = 1;
    			$newscomments_dat['comment_text'] = $newscommentsarray['text'];
    			$newscomments_dat['comment_plonk'] = 0;
    			$newscomments_dat['comment_signature'] = 0;
    			$newscomments_dat['comment_smilies'] = 1;
    			$newscomments_dat['comment_bcode'] = 0;
    			$newscomments_dat['comment_time'] = date("Y-m-d H:i:s", $newscommentsarray['date']);
    			$newscomments_dat['comment_postip'] = $newscommentsarray['ipaddress'];
    			$newscomments_dat['comment_editip'] = $newscommentsarray['ipaddress'];
    			$newscomments[] = $newscomments_dat;
    		}
    	}
    	else
    	{
    		$newscomments = 0;
    	}

    	return $newscomments;
    }

/**
 * function articlescategories
 * A function to get the the number of article/review categories from a Miraserver database
 * @author Philipp Louis Esselbach
 */

	function articlescategories()
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."sections WHERE cat_status = '1'" );
		list( $articlescategories ) = mysqli_fetch_row( $query );
		return $articlescategories;
	}

/**
 * function articlescategoriesimport
 * A function to import article/review categories from a Miraserver database
 * @author Philipp Louis Esselbach
 */

	function articlescategoriesimport()
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT * FROM ".$preferences['acquire_db_prefix']."sections WHERE parent = '0' AND cat_status = '1'" );

		if( mysqli_num_rows( $query ) )
		{
			$articlescategories = array();
			$position = 1;

			while( $articlescategoriesarray = mysqli_fetch_array( $query ) )
			{
				$articlescategories_dat = array();
				$articlescategories_dat['reviewcat_id' ] = $articlescategoriesarray['id'];
				$articlescategories_dat['reviewcat_name' ] = stripslashes($articlescategoriesarray['name']);
				$articlescategories_dat['reviewcat_desc' ] = stripslashes(strip_tags($articlescategoriesarray['content']));
				$articlescategories_dat['reviewcat_parents' ] = $articlescategoriesarray['parentlist'];
				$articlescategories_dat['reviewcat_parentcat' ] = $articlescategoriesarray['parent'];
				$articlescategories_dat['reviewcat_parentid' ] = ( $articlescategoriesarray['parent'] ) ? 2 : 1 ;
				$articlescategories_dat['reviewcat_postip' ] = "::1";
				$articlescategories_dat['reviewcat_editip' ] = "::1";
				$articlescategories_dat['reviewcat_position' ] = $position;
				$articlescategories[] = $articlescategories_dat;

				$position++;

				$query2 = mysqli_query($import_db_link, "SELECT * FROM ".$preferences['acquire_db_prefix']."sections WHERE parent = '" . intval( $articlescategories_dat['reviewcat_id' ] ) ."' AND cat_status = '1'" );
        		if( mysqli_num_rows( $query2 ) )
        		{
        			while( $articlescategoriesarray = mysqli_fetch_array( $query2 ) )
        			{
        				$articlescategories_dat = array();
        				$articlescategories_dat['reviewcat_id' ] = $articlescategoriesarray['id'];
        				$articlescategories_dat['reviewcat_name' ] = stripslashes($articlescategoriesarray['name']);
        				$articlescategories_dat['reviewcat_desc' ] = stripslashes(strip_tags($articlescategoriesarray['content']));
        				$articlescategories_dat['reviewcat_parents' ] = $articlescategoriesarray['parentlist'];
        				$articlescategories_dat['reviewcat_parentcat' ] = $articlescategoriesarray['parent'];
        				$articlescategories_dat['reviewcat_parentid' ] = ( $articlescategoriesarray['parent'] ) ? 2 : 1 ;
        				$articlescategories_dat['reviewcat_postip' ] = "::1";
        				$articlescategories_dat['reviewcat_editip' ] = "::1";
        				$articlescategories_dat['reviewcat_position' ] = $position;
        				$articlescategories[] = $articlescategories_dat;

        				$position++;

						$query3 = mysqli_query($import_db_link, "SELECT * FROM ".$preferences['acquire_db_prefix']."sections WHERE parent = '" . intval( $articlescategories_dat['reviewcat_id' ] ) ."' AND cat_status = '1'" );
		        		if( mysqli_num_rows( $query3 ) )
		        		{
		        			while( $articlescategoriesarray = mysqli_fetch_array( $query3 ) )
		        			{
		        				$articlescategories_dat = array();
		        				$articlescategories_dat['reviewcat_id' ] = $articlescategoriesarray['id'];
		        				$articlescategories_dat['reviewcat_name' ] = stripslashes($articlescategoriesarray['name']);
		        				$articlescategories_dat['reviewcat_desc' ] = stripslashes(strip_tags($articlescategoriesarray['content']));
		        				$articlescategories_dat['reviewcat_parents' ] = $articlescategoriesarray['parentlist'];
		        				$articlescategories_dat['reviewcat_parentcat' ] = $articlescategoriesarray['parent'];
		        				$articlescategories_dat['reviewcat_parentid' ] = 3;
		        				$articlescategories_dat['reviewcat_postip' ] = "::1";
		        				$articlescategories_dat['reviewcat_editip' ] = "::1";
		        				$articlescategories_dat['reviewcat_position' ] = $position;
		        				$articlescategories[] = $articlescategories_dat;

		        				$position++;
		        			}
		        		}
        			}
        		}
			}
		}
		else
		{
			$articlescategories = 0;
		}

		return $articlescategories;
	}

/**
 * function articles
 * A function to get the the number of articles/reviews from a Miraserver database
 * @author Philipp Louis Esselbach
 */
	function articles()
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."mainlist" );
		list( $articles ) = mysqli_fetch_row( $query );
		return $articles;
	}

/**
 * function articlesimport
 * A function to import articles/reviews from a Miraserver database
 * @author Philipp Louis Esselbach
 */
	function articlesimport( $start, $entries )
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT * FROM ".$preferences['acquire_db_prefix']."mainlist LIMIT " . intval( $start ) . ", " . intval( $entries ) );

		if( mysqli_num_rows( $query ) )
		{
			$articles = array();

			mysqli_query($import_db_link, "DELETE FROM ".$preferences['acquire_db_prefix']."pages WHERE id = '78' AND articleid = '21' AND pagenum = '1'" );
			mysqli_query($import_db_link, "DELETE FROM ".$preferences['acquire_db_prefix']."pages WHERE id = '2307' AND articleid = '278' AND pagenum = '1'" );

			while( $articlesarray = mysqli_fetch_array( $query ) )
			{
				$articles_dat = array();
				$articles_dat[ 'review_id' ] = $articlesarray[ 'id'];
				$articles_dat[ 'review_title' ] = stripslashes($articlesarray[ 'title']);
				$articles_dat[ 'review_summary' ] = stripslashes($articlesarray[ 'summary']);
				$articles_dat[ 'review_date' ] =  date("Y-m-d H:i:s", $articlesarray[ 'dateposted' ]);
				$articles_dat[ 'review_html' ] = 1;
				$articles_dat[ 'review_icon' ] = 0;
				$articles_dat[ 'review_code' ] = 0;

				$query2 = mysqli_query($import_db_link, "SELECT name FROM ".$preferences['acquire_db_prefix']."authors WHERE authorid = '" . intval( $articlesarray[ 'author'] ) . "'");
				list($authorname) = mysqli_fetch_row($query2);
				$articles_dat[ 'review_author' ] = $authorname;

				$query3 = mysqli_query($import_db_link, "SELECT cat FROM ".$preferences['acquire_db_prefix']."mainlist_cats WHERE id = '" . intval( $articlesarray[ 'id'] ) . "'");
				list($cat) = mysqli_fetch_row($query3);
				$articles_dat[ 'review_category' ] = $cat;

				$query4 = mysqli_query($import_db_link, "SELECT * FROM ".$preferences['acquire_db_prefix']."pages WHERE articleid = '" . intval( $articlesarray[ 'id'] ) . "' ORDER BY pagenum" );
				while( $pagessarray = mysqli_fetch_array( $query4 ) )
				{
					$articles_dat[ 'review_page' ] = $pagessarray[ 'pagenum' ];
					$articles_dat[ 'review_text' ] = stripslashes($pagessarray[ 'content' ]);

	    			preg_match_all("/\"http:\/\/(.*){imgdir}\?image=(.*)\"|\"{imgdir}\?image=(.*)\"/Ui", $articles_dat['review_text'], $matches, PREG_SET_ORDER);
	    			foreach( $matches as $match )
	    			{
	    				$this_match = ( isset( $match[3] ) ) ? $match[3] : $match[2] ;
	    				$query2 = mysqli_query($import_db_link, "SELECT filename, path FROM ".$preferences['acquire_db_prefix']."images WHERE id = '" . intval( $this_match ) ."'" );
	    				while( list( $image_filename, $image_path ) = mysqli_fetch_row( $query2 ) )
	    				{
	    					$this_image = ( $image_path ) ? "miraserver/images/" . $image_path . $image_filename : "miraserver/images/" . $image_filename ;

    						if( isset( $match[3]) )
    						{
	    						$articles_dat['review_text'] = str_replace( "{imgdir}?image=" . $match[3], $this_image, $articles_dat['review_text'] );
    						}
    						else
    						{
    							$articles_dat['review_text'] = str_replace( "http://" . $match[1] . "{imgdir}?image=" . $match[2], $this_image, $articles_dat['review_text'] );
    						}
	    				}
	    			}

					if( $pagessarray[ 'subtitle' ] )
					{
						$articles_dat[ 'review_pagesup' ] = stripslashes($pagessarray[ 'subtitle' ]);
					}
					else
					{
						$articles_dat[ 'review_pagesup' ] = "Page " . $pagessarray[ 'pagenum' ];
					}

					$articles[] = $articles_dat;
				}
			}
		}
		else
		{
			$articles = 0;
		}
		return $articles;
	}

/**
 * function knowledgebasecategories
 * Dummy function to return zero knowledgebase/FAQ categories
 * @author Philipp Louis Esselbach
 */

    function knowledgebasecategories()
    {
    	return 0;
    }

/**
 * function knowledgebaseentries
 * A function to get the the number of knowledgebase/FAQ entries from a Miraserver database
 * @author Philipp Louis Esselbach
 */

    function knowledgebaseentries()
    {
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."faq_entries" );
		list( $knowledgebaseentries ) = mysqli_fetch_row( $query );
		return $knowledgebaseentries;
    }

/**
 * function knowledgebaseimport
 * A function to import knowledgebase/FAQ entries from a Miraserver database
 * @author Philipp Louis Esselbach
 */

	function knowledgebaseimport( $start, $entries )
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT * FROM ".$preferences['acquire_db_prefix']."faq_entries LIMIT " . intval( $start ) . ", " . intval( $entries ) );

		if( mysqli_num_rows( $query ) )
		{
			$knowledgebaseentries = array();

			while( $knowledgebasearray = mysqli_fetch_array( $query ) )
			{
				$knowledgebaseentries_dat = array();

				$knowledgebaseentries_dat[ 'faq_website' ] = 0;
				$knowledgebaseentries_dat[ 'faq_author' ] = "";
				$knowledgebaseentries_dat[ 'faq_id' ] = $knowledgebasearray[ 'faq_id' ];
				$knowledgebaseentries_dat[ 'faq_question' ] = $knowledgebasearray[ 'question' ];
				$knowledgebaseentries_dat[ 'faq_answer_text' ] = stripslashes( $knowledgebasearray[ 'answer' ] );
				$knowledgebaseentries_dat[ 'faq_html' ] = 1;
				$knowledgebaseentries_dat[ 'faq_icon' ] = 0;
				$knowledgebaseentries_dat[ 'faq_code' ] = 0;
				$knowledgebaseentries_dat[ 'faq_postip' ] = "::1";
				$knowledgebaseentries_dat[ 'faq_editip' ] = "::1";
				$knowledgebaseentries[ ] = $knowledgebaseentries_dat;
			}
		}
		else
		{
			$knowledgebaseentries = 0;
		}

		return $knowledgebaseentries;
	}

/**
 * function filescategories
 * Dummy function to return zero file categories
 * @author Philipp Louis Esselbach
 */

    function filescategories()
    {
    	return 0;
    }

/**
 * function files
 * Dummy function to return zero files
 * @author Philipp Louis Esselbach
 */

    function files()
    {
    	return 0;
    }

/**
 * function filescomments
 * Dummy function to return zero file comments
 * @author Philipp Louis Esselbach
 */

    function filescomments()
    {
    	return 0;
    }

/**
 * function glossary
 * Dummy function to return zero glossary entries
 * @author Philipp Louis Esselbach
 */

    function glossary()
    {
    	return 0;
    }
}

?>