<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.18                                                  |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2016 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Patch #5                                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Acquire
 * @copyright (C) 2002-2016 Esselbach Internet Solutions
 */

/**
 * class acquire
 * A class that contains routines to import data from a vBulletin 4 CMS database
 * @author Philipp Louis Esselbach
 * @package Contentteller
 */

class acquire
{

/**
 * function dbconnect
 * A function to connect to a vBulletin 4 CMS MySQL database
 * @author Philipp Louis Esselbach
 */

	function dbconnect()
    {
        global $preferences, $words_acquire, $import_db_link;

        $error = "";

        $import_db_link = @mysqli_connect($preferences['acquire_db_hostname'], $preferences['acquire_db_username'], $preferences['acquire_db_password'], $preferences['acquire_db_name']) or $error = $words_acquire['FATAL_CAN_NOT_CONNECT_SERVER'];

        return $error;
    }

/**
 * function dbclose
 * A function to close the connection to the vBulletin 4 CMS MySQL database
 * @author Philipp Louis Esselbach
 */

    function dbclose()
    {
    	global $import_db_link;

        mysqli_close($import_db_link);
    }

/**
 * function users
 * Dummy function to return zero users
 * @author Philipp Louis Esselbach
 */

    function users()
    {
    	return 0;
    }

/**
 * function usersimport
 * Dummy function to return zero users
 * @author Philipp Louis Esselbach
 */

    function usersimport($start, $users)
    {
    	return 0;
    }

/**
 * function content
 * Dummy function to return zero pages
 * @author Philipp Louis Esselbach
 */

    function content()
    {
    	return 0;
    }

/**
 * function contentpagesimport
 * Dummy function to return zero pages
 * @author Philipp Louis Esselbach
 */

    function contentpagesimport($start, $pages)
    {
    	return 0;
    }

/**
 * function newscategories
 * A function to get the the number of news categories from a vBulletin 4 CMS database
 * @author Philipp Louis Esselbach
 */

    function newscategories()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(categoryid) FROM " . $preferences[ 'acquire_db_prefix' ] . "cms_category");
    	list($newscategories) = mysqli_fetch_row($query);

    	return $newscategories;
    }

/**
 * function newscategoriesimport
 * A function to import news categories from a vBulletin 4 CMS database
 * @author Philipp Louis Esselbach
 */

    function newscategoriesimport()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ". $preferences[ 'acquire_db_prefix' ].  "cms_category");
    	if (mysqli_num_rows($query))
    	{
    		$newscategories = array();
    		while($newscategoriesarray = mysqli_fetch_array($query))
    		{
    			$newscategories_dat = array();
    			$newscategories_dat['category_id'] = $newscategoriesarray['categoryid'];
    			$newscategories_dat['category_name'] = $newscategoriesarray['category'];
    			$newscategories_dat['category_desc'] = "";
    			$newscategories_dat['category_parent'] = "";
    			$newscategories_dat['category_permissions'] = "";
    			$newscategories_dat['category_postip'] = "::1";
    			$newscategories_dat['category_editip'] = "::1";
    			$newscategories[] = $newscategories_dat;
    		}
    	}
    	else
    	{
    		$newscategories = 0;
    	}

    	return $newscategories;
    }

/**
 * function newsstories
 * A function to get the the number of news stories from a vBulletin 4 CMS database
 * @author Philipp Louis Esselbach
 */

    function newsstories()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(contentid) FROM " . $preferences['acquire_db_prefix'] . "cms_article");
    	list($newsstories) = mysqli_fetch_row($query);

    	return $newsstories;
    }

/**
 * function newsstoriesimport
 * A function to import news stories from a vBulletin 4 CMS database
 * @author Philipp Louis Esselbach
 */

    function newsstoriesimport($start, $stories)
    {
    	global $import_db_link, $preferences, $login_username;

    	$query = mysqli_query($import_db_link,"SELECT * FROM " . $preferences['acquire_db_prefix'] . "cms_article a, " . $preferences['acquire_db_prefix'] . "cms_node n WHERE a.contentid = n.contentid LIMIT ".intval($start).", ".intval($stories));

    	if (mysqli_num_rows($query))
    	{
    		$newsstories = array();
    		while($newsstoriesarray = mysqli_fetch_array($query))
    		{
    			$newsstories_dat = array();
    			$newsstories_dat['story_id'] = $newsstoriesarray['contentid'];
    			$newsstories_dat['story_website'] = 0;
    			$newsstories_dat['story_category'] = $newsstoriesarray['parentnode'];
    			$newsstories_dat['story_author'] = ( $newsstoriesarray['postauthor'] ) ? $newsstoriesarray['postauthor'] : $login_username;

    			$subquery = mysqli_query($import_db_link,"SELECT title, associatedthreadid FROM " . $preferences['acquire_db_prefix'] . "cms_nodeinfo WHERE nodeid = '" . $newsstoriesarray['nodeid'] . "'");
    			list( $title, $associatedthreadid) = mysqli_fetch_row( $subquery );
    			$newsstories_dat['story_title'] = $title;
    			$newsstories_dat['story_text'] = str_replace( array( "\n", "[PRBREAK][/PRBREAK]") , "\r\n", $newsstoriesarray['pagetext'] );
    			$newsstories_dat['story_text'] = str_replace( array( "[TABLE]", "[TR]", "[TD]", "[/TD]", "[/TR]", "[/TABLE]" ) , "", $newsstories_dat['story_text'] );
    			$newsstories_dat['story_text'] = preg_replace( "/\[PAGE\](.*)\[\/PAGE\]/i", "[b]\\1[/b]", $newsstories_dat['story_text'] );
    			$newsstories_dat['story_text'] = preg_replace( "/\[video=youtube\;(.*?)\](.*?)\[\/video\]/i", "[youtube=\\1]", $newsstories_dat['story_text'] );

    			preg_match_all( "/\[ATTACH=CONFIG\](.*)\[\/ATTACH\]|\[ATTACH\](.*)\[\/ATTACH\]/Ui", $newsstories_dat['story_text'], $matches, PREG_SET_ORDER );
				foreach( $matches as $match )
				{
					if( isset( $match[2] ) )
					{
						$newsstories_dat['story_text'] = str_replace( $match[0], "[fullimage=" . $match[2] . "]\r\n\r\n", $newsstories_dat['story_text'] );
					}
					else
					{
						$newsstories_dat['story_text'] = str_replace( $match[0], "[fullimage=" . $match[1] . "]\r\n\r\n", $newsstories_dat['story_text'] );
					}
				}
    			$newsstories_dat['story_extendedtext'] = "";
    			$newsstories_dat['story_main'] = 1;
    			$newsstories_dat['story_time'] = date("Y-m-d H:i:s", $newsstoriesarray['publishdate'] );

    			if( $associatedthreadid )
    			{
    				$subquery = mysqli_query($import_db_link,"SELECT postid FROM " . $preferences['acquire_db_prefix'] . "post WHERE threadid = '" . $associatedthreadid . "' AND NOT(parentid = '0') ORDER BY postid", $import_db_link);
    				$comments = mysqli_num_rows( $subquery );
    			}
    			else
    			{
    				$comments = 0;
    			}

    			$newsstories_dat['story_comments'] = $comments;
    			$newsstories_dat['story_source'] = "";
    			$newsstories_dat['story_teaser'] = "";
    			$newsstories_dat['story_extra1'] = "";
    			$newsstories_dat['story_extra2'] = "";
    			$newsstories_dat['story_extra3'] = "";
    			$newsstories_dat['story_extra4'] = "";
    			$newsstories_dat['story_extra5'] = "";
    			$newsstories_dat['story_extra6'] = "";
    			$newsstories_dat['story_extra7'] = "";
    			$newsstories_dat['story_extra8'] = "";
    			$newsstories_dat['story_extra9'] = "";
    			$newsstories_dat['story_extra10'] = "";
    			$newsstories_dat['story_extra11'] = "";
    			$newsstories_dat['story_extra12'] = "";
    			$newsstories_dat['story_extra13'] = "";
    			$newsstories_dat['story_extra14'] = "";
    			$newsstories_dat['story_extra15'] = "";
    			$newsstories_dat['story_extra16'] = "";
    			$newsstories_dat['story_extra17'] = "";
    			$newsstories_dat['story_extra18'] = "";
    			$newsstories_dat['story_extra19'] = "";
    			$newsstories_dat['story_extra20'] = "";
    			$newsstories_dat['story_html'] = 0;
    			$newsstories_dat['story_icon'] = 1;
    			$newsstories_dat['story_code'] = 1;
    			$newsstories_dat['story_postip'] = "::1";
    			$newsstories_dat['story_editip'] = "::1";
    			$newsstories_dat['story_editreason'] = "";
    			$newsstories_dat['story_hook'] = "0";
    			$newsstories_dat['story_sticky'] = "0";
    			$newsstories_dat['story_comm'] = "0";
    			$newsstories[] = $newsstories_dat;
    		}
    	}
    	else
    	{
    		$newsstories = 0;
    	}
    	return $newsstories;
    }

/**
 * function newsattachments
 * A function to get the the number of news attachments from a vBulletin 4 CMS database
 * @author Philipp Louis Esselbach
 */

    function newsattachments()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(attachmentid) FROM " . $preferences['acquire_db_prefix'] . "attachment");
    	list($newsattachments) = mysqli_fetch_row($query);

    	return $newsattachments;
    }

/**
 * function newsattachmentsimport
 * A function to import news attachments from a vBulletin 4 CMS database
 * @author Philipp Louis Esselbach
 */

    function newsattachmentsimport($start, $attachments)
    {
    	global $import_db_link, $preferences, $login_username;

    	$query = mysqli_query($import_db_link,"SELECT * FROM " . $preferences['acquire_db_prefix'] . "attachment a, " . $preferences['acquire_db_prefix'] . "filedata f WHERE a.filedataid=f.filedataid LIMIT ".intval($start).", ".intval($attachments));
    	if (mysqli_num_rows($query))
    	{
    		$newsattachments = array();
    		while($newsattachmentsarray = mysqli_fetch_array($query))
    		{
    			$newsattachments_dat = array();
    			$newsattachments_dat['newsfile_id'] = $newsattachmentsarray['filedataid'];
    			$newsattachments_dat['newsfile_filename'] = $newsattachmentsarray['filename'];
    			$newsattachments_dat['newsfile_binary'] = $newsattachmentsarray['filedata'];
    			$newsattachments[] = $newsattachments_dat;
    		}
    	}
    	else
    	{
    		$newsattachments = 0;
    	}

    	return $newsattachments;
    }

/**
 * function newscomments
 * A function to get the the number of news comments from a vBulletin 4 CMS database
 * @author Philipp Louis Esselbach
 */

    function newscomments()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT forumid FROM ".$preferences['acquire_db_prefix']."forum WHERE title='vBCms Comments'");
    	list( $forumid ) = mysqli_fetch_row( $query );

    	$newscomments = 0;
    	$query = mysqli_query($import_db_link,"SELECT replycount FROM ".$preferences['acquire_db_prefix']."thread WHERE forumid = '" . $forumid . "'");
    	while( list( $replies ) = mysqli_fetch_row($query) )
    	{
    		$newscomments = $newscomments + $replies;
    	}

    	return $newscomments;
    }

/**
 * function newscommentsimport
 * A function to import news comments from a vBulletin 4 CMS database
 * @author Philipp Louis Esselbach
 */

    function newscommentsimport($start, $comments)
    {
    	global $import_db_link, $preferences;

    	 $query = mysqli_query($import_db_link,"SELECT i.associatedthreadid, n.contentid FROM " . $preferences['acquire_db_prefix'] . "cms_node n, " . $preferences['acquire_db_prefix'] . "cms_nodeinfo i WHERE n.nodeid = i.nodeid AND NOT(i.associatedthreadid = '0') LIMIT ".intval($start).", ".intval($comments));
    	if (mysqli_num_rows($query))
    	{
    		$newscomments = array();
    		while( list($associatedthreadid, $contentid) = mysqli_fetch_row( $query ) )
    		{
				$subquery = mysqli_query($import_db_link,"SELECT * FROM " . $preferences['acquire_db_prefix'] . "post WHERE threadid = '" . $associatedthreadid . "' AND NOT(parentid = '0') ORDER BY postid");
	    		while($newscommentsarray = mysqli_fetch_array($subquery))
	    		{
	    			$newscomments_dat = array();
	    			$newscomments_dat['comment_id'] = $newscommentsarray['postid'];
	    			$newscomments_dat['comment_website'] = 0;
	    			$newscomments_dat['comment_category'] = 1;
	    			$newscomments_dat['comment_author'] = $newscommentsarray['username'];
	    			$newscomments_dat['comment_story'] = $contentid;
	    			$newscomments_dat['comment_icon'] = 1;
	    			$newscomments_dat['comment_text'] = str_replace( "[QUOTE=;][/QUOTE]\n", "", $newscommentsarray['pagetext']);
	    			$newscomments_dat['comment_plonk'] = 0;
	    			$newscomments_dat['comment_signature'] = 0;
	    			$newscomments_dat['comment_smilies'] = 0;
	    			$newscomments_dat['comment_bcode'] = 0;
	    			$newscomments_dat['comment_time'] = date("Y-m-d H:i:s", $newscommentsarray['dateline']);
	    			$newscomments_dat['comment_postip'] = $newscommentsarray['ipaddress'];
	    			$newscomments_dat['comment_editip'] = $newscommentsarray['ipaddress'];
	    			$newscomments[] = $newscomments_dat;
	    		}
    		}
    	}
    	else
    	{
    		$newscomments = 0;
    	}

    	return $newscomments;
    }

/**
 * function articlescategories
 * Dummy function to return zero article/review categories
 * @author Philipp Louis Esselbach
 */

    function articlescategories()
    {
    	return 0;
    }

/**
 * function articles
 * Dummy function to return zero article/review
 * @author Philipp Louis Esselbach
 */

    function articles()
    {
    	return 0;
    }

/**
 * function knowledgebasecategories
 * Dummy function to return zero knowledgebase/FAQ categories
 * @author Philipp Louis Esselbach
 */

    function knowledgebasecategories()
    {
    	return 0;
    }

/**
 * function knowledgebaseentries
 * Dummy function to return zero knowledgebase/FAQ entries
 * @author Philipp Louis Esselbach
 */

    function knowledgebaseentries()
    {
    	return 0;
    }

/**
 * function filescategories
 * Dummy function to return zero file categories
 * @author Philipp Louis Esselbach
 */

    function filescategories()
    {
    	return 0;
    }

/**
 * function files
 * Dummy function to return zero files
 * @author Philipp Louis Esselbach
 */

    function files()
    {
    	return 0;
    }

/**
 * function filescomments
 * Dummy function to return zero file comments
 * @author Philipp Louis Esselbach
 */

    function filescomments()
    {
    	return 0;
    }

/**
 * function glossary
 * Dummy function to return zero glossary entries
 * @author Philipp Louis Esselbach
 */

    function glossary()
    {
    	return 0;
    }
}

?>