<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.18                                                  |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2016 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Patch #5                                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Acquire
 * @copyright (C) 2002-2016 Esselbach Internet Solutions
 */

/**
 * class acquire
 * A class that contains routines to import data from a VirtuaNews database
 * @author Philipp Louis Esselbach
 * @package Contentteller
 */

class acquire
{

/**
 * function dbconnect
 * A function to connect to a VirtuaNews MySQL database
 * @author Philipp Louis Esselbach
 */

	function dbconnect()
    {
        global $preferences, $words_acquire;

        $error = "";

        $import_db_link = @mysqli_connect($preferences['acquire_db_hostname'], $preferences['acquire_db_username'], $preferences['acquire_db_password'], $preferences['acquire_db_name']) or $error = $words_acquire['FATAL_CAN_NOT_CONNECT_SERVER'];

        return $error;
    }

/**
 * function dbclose
 * A function to close the connection to the VirtuaNews MySQL database
 * @author Philipp Louis Esselbach
 */

    function dbclose()
    {
    	global $import_db_link;

        mysqli_close($import_db_link);
    }

/**
 * function users
 * A function to get the the number of user accounts from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

    function users()
    {
    	global $import_db_link, $preferences;
    	$query = mysqli_query($import_db_link,"SELECT COUNT(userid) FROM ".$preferences['acquire_db_prefix']."user");
    	list($users) = mysqli_fetch_row($query);

    	return $users;
    }

/**
 * function usersimport
 * A function to import user accounts from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

    function usersimport($start, $users)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."user LIMIT ".intval($start).", ".intval($users));
    	if (mysqli_num_rows($query))
    	{
    		$users = array();
    		while($usersarray = mysqli_fetch_array($query))
    		{
    			$users_dat = array();
    			$users_dat['user_id'] = $usersarray['userid'];
    			$users_dat['user_loginname'] = $usersarray['username'];
    			$users_dat['user_name'] = $usersarray['username'];
    			$users_dat['user_password'] = $usersarray['password'];
    			$users_dat['user_posts'] = $usersarray['posts'];
    			$users_dat['user_birthday'] = "";
    			$users_dat['user_homepage'] = $usersarray['homepage'];
    			$users_dat['user_email'] = $usersarray['email'];
    			$users_dat['user_regemail'] = $usersarray['email'];
    			$users_dat['user_icq'] = $usersarray['icq'];
    			$users_dat['user_aim'] = $usersarray['aim'];
    			$users_dat['user_yam'] = $usersarray['yahoo'];
    			$users_dat['user_ms'] = "";
    			$users_dat['user_jabber'] = "";
    			$users_dat['user_occupation'] = "";
    			$users_dat['user_interests'] = "";
    			$users_dat['user_picture'] = "";
    			$users_dat['user_signature'] = $usersarray['signature'];
    			$users_dat['user_cconfig'] = "";
    			$users_dat['user_banned'] = $usersarray['isbanned'];
    			$users_dat['user_bannedreason'] = "";
    			$users_dat['user_securekey'] = "";
    			$users_dat['user_regip'] = "::1";
    			$users_dat['user_editip'] = "::1";
    			$users[] = $users_dat;
    		}
    	}
    	else
    	{
    		$users = 0;
    	}

    	return $users;
    }

/**
 * function content
 * A function to get the the number of content pages from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

    function content()
    {
		return 0;
    }

/**
 * function newscategories
 * A function to get the the number of news categories from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

    function newscategories()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."category");
    	list($newscategories) = mysqli_fetch_row($query);

    	return $newscategories;
    }

/**
 * function newscategoriesimport
 * A function to import news categories from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

    function newscategoriesimport()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."category");
    	if (mysqli_num_rows($query))
    	{
    		$newscategories = array();
    		while($newscategoriesarray = mysqli_fetch_array($query))
    		{
    			$newscategories_dat = array();
    			$newscategories_dat['category_id'] = $newscategoriesarray['id'];
    			$newscategories_dat['category_name'] = $newscategoriesarray['name'];
    			$newscategories_dat['category_desc'] = $newscategoriesarray['description'];
    			$newscategories_dat['category_parent'] = "";
    			$newscategories_dat['category_permissions'] = "";
    			$newscategories_dat['category_postip'] = "::1";
    			$newscategories_dat['category_editip'] = "::1";
    			$newscategories[] = $newscategories_dat;
    		}
    	}
    	else
    	{
    		$newscategories = 0;
    	}

    	return $newscategories;
    }

/**
 * function newsstories
 * A function to get the the number of news stories from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

    function newsstories()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."news");
    	list($newsstories) = mysqli_fetch_row($query);

    	return $newsstories;
    }

/**
 * function newsstoriesimport
 * A function to import news stories from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

    function newsstoriesimport($start, $stories)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."news LIMIT ".intval($start).", ".intval($stories));

    	if (mysqli_num_rows($query))
    	{
    		$newsstories = array();
    		while($newsstoriesarray = mysqli_fetch_array($query))
    		{
    			$newsstories_dat = array();
    			$newsstories_dat['story_id'] = $newsstoriesarray['id'];
    			$newsstories_dat['story_website'] = 0;
    			$newsstories_dat['story_category'] = $newsstoriesarray['catid'];

    			$query2 = mysqli_query($import_db_link,"SELECT username FROM ".$preferences['acquire_db_prefix']."user WHERE userid = '".intval($newsstoriesarray['staffid'])."'");
    			list($user_name) = mysqli_fetch_row($query2);

    			if (!$user_name)
    			{
    				$user_name = "Unknown";
    			}

    			$newsstories_dat['story_author'] = $user_name;

    			$newsstories_dat['story_title'] = $newsstoriesarray['title'];
    			$newsstories_dat['story_text'] = strip_tags($newsstoriesarray['mainnews']);
    			$newsstories_dat['story_extendedtext'] = strip_tags($newsstoriesarray['extendednews']);
    			$newsstories_dat['story_main'] = 1;
    			$newsstories_dat['story_time'] = date("Y-m-d H:i:s", $newsstoriesarray['time']);
    			$newsstories_dat['story_comments'] = $newsstoriesarray['commentcount'];
    			$newsstories_dat['story_source'] = "";
    			$newsstories_dat['story_teaser'] = $newsstoriesarray['logoimage'];
    			$newsstories_dat['story_extra1'] = "";
    			$newsstories_dat['story_extra2'] = "";
    			$newsstories_dat['story_extra3'] = "";
    			$newsstories_dat['story_extra4'] = "";
    			$newsstories_dat['story_extra5'] = "";
    			$newsstories_dat['story_extra6'] = "";
    			$newsstories_dat['story_extra7'] = "";
    			$newsstories_dat['story_extra8'] = "";
    			$newsstories_dat['story_extra9'] = "";
    			$newsstories_dat['story_extra10'] = "";
    			$newsstories_dat['story_extra11'] = "";
    			$newsstories_dat['story_extra12'] = "";
    			$newsstories_dat['story_extra13'] = "";
    			$newsstories_dat['story_extra14'] = "";
    			$newsstories_dat['story_extra15'] = "";
    			$newsstories_dat['story_extra16'] = "";
    			$newsstories_dat['story_extra17'] = "";
    			$newsstories_dat['story_extra18'] = "";
    			$newsstories_dat['story_extra19'] = "";
    			$newsstories_dat['story_extra20'] = "";
    			$newsstories_dat['story_html'] = 0;
    			$newsstories_dat['story_icon'] = 1;
    			$newsstories_dat['story_code'] = 1;
    			$newsstories_dat['story_postip'] = "::1";
    			$newsstories_dat['story_editip'] = "::1";
    			$newsstories_dat['story_editreason'] = "";
    			$newsstories_dat['story_hook'] = "0";
    			$newsstories_dat['story_sticky'] = "0";
    			$newsstories_dat['story_comm'] = "0";
    			$newsstories[] = $newsstories_dat;
    		}
    	}
    	else
    	{
    		$newsstories = 0;
    	}

    	return $newsstories;
    }

/**
 * function newsattachments
 * Dummy function to return zero news attachments
 * @author Philipp Louis Esselbach
 */
    function newsattachments()
    {
    	return 0;
    }

/**
 * function newscomments
 * A function to get the the number of news comments from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

    function newscomments()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."comment");
    	list($newscomments) = mysqli_fetch_row($query);

    	return $newscomments;
    }

/**
 * function newscommentsimport
 * A function to import news comments from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

    function newscommentsimport($start, $comments)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."comment LIMIT ".intval($start).", ".intval($comments));
    	if (mysqli_num_rows($query))
    	{
    		$newscomments = array();
    		while($newscommentsarray = mysqli_fetch_array($query))
    		{
    			$newscomments_dat = array();
    			$newscomments_dat['comment_id'] = $newscommentsarray['id'];
    			$newscomments_dat['comment_website'] = 0;
    			$newscomments_dat['comment_category'] = 1;
    			$newscomments_dat['comment_author'] = $newscommentsarray['username'];
    			$newscomments_dat['comment_story'] = $newscommentsarray['newsid'];
    			$newscomments_dat['comment_icon'] = 1;
    			$newscomments_dat['comment_text'] = $newscommentsarray['comment'];
    			$newscomments_dat['comment_plonk'] = 0;
    			$newscomments_dat['comment_signature'] = $newscommentsarray['showsig'];
    			$newscomments_dat['comment_smilies'] = 1;
    			$newscomments_dat['comment_bcode'] = 0;
    			$newscomments_dat['comment_time'] = date("Y-m-d H:i:s", $newscommentsarray['time']);
    			$newscomments_dat['comment_postip'] = $newscommentsarray['ip'];
    			$newscomments_dat['comment_editip'] = $newscommentsarray['ip'];
    			$newscomments[] = $newscomments_dat;
    		}
    	}
    	else
    	{
    		$newscomments = 0;
    	}

    	return $newscomments;
    }

/**
 * function articlescategories
 * A function to get the the number of article/review categories from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

	function articlescategories()
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."articlecat" );
		list( $articlescategories ) = mysqli_fetch_row( $query );
		return $articlescategories;
	}

/**
 * function articlescategoriesimport
 * A function to import article/review categories from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

	function articlescategoriesimport()
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT * FROM ".$preferences['acquire_db_prefix']."articlecat" );

		if( mysqli_num_rows( $query ) )
		{
			$articlescategories = array();

			while( $articlescategoriesarray = mysqli_fetch_array( $query ) )
			{
				$articlescategories_dat = array();
				$articlescategories_dat['reviewcat_id' ] = $articlescategoriesarray['id'];
				$articlescategories_dat['reviewcat_name' ] = $articlescategoriesarray['title'];
				$articlescategories_dat['reviewcat_desc' ] = $articlescategoriesarray['description'];
				$articlescategories_dat['reviewcat_postip' ] = "::1";
				$articlescategories_dat['reviewcat_editip' ] = "::1";
				$articlescategories[] = $articlescategories_dat;
			}
		}
		else
		{
			$articlescategories = 0;
		}

		return $articlescategories;
	}

/**
 * function articles
 * A function to get the the number of articles/reviews from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */
	function articles()
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."article" );
		list( $articles ) = mysqli_fetch_row( $query );
		return $articles;
	}

/**
 * function articlesimport
 * A function to import articles/reviews from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */
	function articlesimport( $start, $entries )
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT * FROM ".$preferences['acquire_db_prefix']."article LIMIT " . intval( $start ) . ", " . intval( $entries ) );

		if( mysqli_num_rows( $query ) )
		{
			$articles = array();

			while( $articlesarray = mysqli_fetch_array( $query ) )
			{
				for ($x = 1; $x < 11; $x++)
				{
					if ($articlesarray[ 'page' . $x])
					{
						$articles_dat = array();
						$articles_dat[ 'review_author' ] = $articlesarray[ 'authorname'];
						$articles_dat[ 'reviewpage_id' ] = $articlesarray[ 'id'] * 10;
						$articles_dat[ 'review_id' ] = $articlesarray[ 'id'];
						$articles_dat[ 'review_page' ] = $x;
						$articles_dat[ 'review_category' ] = $articlesarray[ 'catid'];
						$articles_dat[ 'review_title' ] = $articlesarray[ 'title'];
						$articles_dat[ 'review_text' ] = strip_tags($articlesarray[ 'page' . $x]);
						$articles_dat[ 'review_pagesup' ] = "Page " . $x;
						$articles_dat[ 'review_date' ] =  date("Y-m-d H:i:s", $articlesarray[ 'date' ]);
						$articles_dat[ 'review_html' ] = 0;
						$articles_dat[ 'review_icon' ] = 1;
						$articles_dat[ 'review_code' ] = 1;
						$articles[] = $articles_dat;
					}
				}
			}
		}
		else
		{
			$articles = 0;
		}
		return $articles;
	}

/**
 * function knowledgebasecategories
 * Dummy function to return zero knowledgebase/FAQ categories
 * @author Philipp Louis Esselbach
 */

    function knowledgebasecategories()
    {
    	return 0;
    }

/**
 * function knowledgebaseentries
 * Dummy function to return zero knowledgebase/FAQ entries
 * @author Philipp Louis Esselbach
 */

    function knowledgebaseentries()
    {
    	return 0;
    }

/**
 * function filescategories
 * A function to get the the number of file categories from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

	function filescategories()
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."filecat" );
		list( $filescategories ) = mysqli_fetch_row( $query );
		return $filescategories;
	}

/**
 * function filescategoriesimport
 * A function to import file categories from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

	function filescategoriesimport()
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT * FROM ".$preferences['acquire_db_prefix']."filecat" );

		if( mysqli_num_rows( $query ) )
		{
			$filescategories = array();

			while( $filescategoriesarray = mysqli_fetch_array( $query ) )
			{
				$filescategories_dat = array();
				$filescategories_dat[ 'downloadscat_id' ] = $filescategoriesarray[ 'id' ];
				$filescategories_dat[ 'downloadscat_name' ] = $filescategoriesarray[ 'name' ];
				$filescategories_dat[ 'downloadscat_desc' ] = $filescategoriesarray[ 'description' ];
				$filescategories_dat[ 'downloadscat_postip' ] = "::1";
				$filescategories_dat[ 'downloadscat_editip' ] = "::1";
				$filescategories[] = $filescategories_dat;
			}
		}
		else
		{
			$filescategories = 0;
		}

		return $filescategories;
	}

/**
 * function files
 * A function to get the the number of files from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

	function files()
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT COUNT(id) FROM ".$preferences['acquire_db_prefix']."file" );
		list( $files ) = mysqli_fetch_row( $query );
		return $files;
	}

/**
 * function filesimport
 * A function to import files from a VirtuaNews database
 * @author Philipp Louis Esselbach
 */

	function filesimport( $start, $entries )
	{
		global $import_db_link, $preferences;
		$query = mysqli_query($import_db_link, "SELECT * FROM ".$preferences['acquire_db_prefix']."file WHERE NOT(url = '') LIMIT " . intval( $start ) . ", " . intval( $entries ) );

		if( mysqli_num_rows( $query ) )
		{
			$files = array();

			while( $filesarray = mysqli_fetch_array( $query ) )
			{
				$files_dat = array();
				$files_dat[ 'download_author'  ] = "Unknow";
				$files_dat[ 'download_id' ] = $filesarray[ 'id' ];
				$files_dat[ 'download_category' ] = $filesarray[ 'catid' ];
				$files_dat[ 'download_title' ] = $filesarray[ 'name' ];
				$files_dat[ 'download_text' ] = strip_tags($filesarray[ 'description' ]);
				$files_dat[ 'download_extendedtext' ] = strip_tags($filesarray[ 'description' ]);
				$files_dat[ 'download_count' ] = $filesarray[ 'downloadcount' ];
				$files_dat[ 'download_time' ] = date( "Y-m-d H:i:s", $filesarray[ 'time' ]);
				$files_dat[ 'download_url1' ] = $filesarray[ 'url' ];
				$files_dat[ 'download_html' ] = 0;
				$files_dat[ 'download_icon' ] = 1;
				$files_dat[ 'download_code' ] = 1;
				$files[] = $files_dat;
			}
		}
		else
		{
			$files = 0;
		}

		return $files;
	}

/**
 * function filescomments
 * Dummy function to return zero file comments
 * @author Philipp Louis Esselbach
 */

    function filescomments()
    {
    	return 0;
    }

/**
 * function glossary
 * Dummy function to return zero glossary entries
 * @author Philipp Louis Esselbach
 */

    function glossary()
    {
    	return 0;
    }
}

?>