<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.18                                                  |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2016 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Patch #5                                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Acquire
 * @copyright (C) 2002-2016 Esselbach Internet Solutions
 */

/**
 * class acquire
 * A class that contains routines to import data from a Wordpress database
 * @author Philipp Louis Esselbach
 * @package Contentteller
 */

class acquire
{

/**
 * function dbconnect
 * A function to connect to a Wordpress MySQL database
 * @author Philipp Louis Esselbach
 */

	function dbconnect()
    {
        global $preferences, $words_acquire;

        $error = "";

        $import_db_link = @mysqli_connect($preferences['acquire_db_hostname'], $preferences['acquire_db_username'], $preferences['acquire_db_password'], $preferences['acquire_db_name']) or $error = $words_acquire['FATAL_CAN_NOT_CONNECT_SERVER'];

        return $error;
    }

/**
 * function dbclose
 * A function to close the connection to the Wordpress MySQL database
 * @author Philipp Louis Esselbach
 */

    function dbclose()
    {
    	global $import_db_link;

        mysqli_close($import_db_link);
    }

/**
 * function users
 * A function to get the the number of user accounts from a Wordpress database
 * @author Philipp Louis Esselbach
 */

    function users()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(ID) FROM ".$preferences['acquire_db_prefix']."users");
    	list($users) = mysqli_fetch_row($query);

    	return $users;
    }

/**
 * function usersimport
 * A function to import user accounts from a Wordpress database
 * @author Philipp Louis Esselbach
 */

    function usersimport($start, $users)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."users LIMIT ".intval($start).", ".intval($users));
    	if (mysqli_num_rows($query))
    	{
    		$users = array();
    		while($usersarray = mysqli_fetch_array($query))
    		{
    			$users_dat = array();
    			$users_dat['user_id'] = $usersarray['ID'];
    			$users_dat['user_loginname'] = $usersarray['user_login'];
    			$users_dat['user_name'] = $usersarray['display_name'];
    			$users_dat['user_password'] = $usersarray['user_password'];
    			$users_dat['user_posts'] = "0";
    			$users_dat['user_birthday'] = "";
    			$users_dat['user_homepage'] = $usersarray['user_url'];
    			$users_dat['user_email'] = $usersarray['user_email'];
    			$users_dat['user_regemail'] = $usersarray['user_email'];
    			$users_dat['user_icq'] = "";
    			$users_dat['user_aim'] = "";
    			$users_dat['user_yam'] = "";
    			$users_dat['user_ms'] = "";
    			$users_dat['user_jabber'] = "";
    			$users_dat['user_occupation'] = "";
    			$users_dat['user_interests'] = "";
    			$users_dat['user_picture'] = "";
    			$users_dat['user_signature'] = "";
    			$users_dat['user_cconfig'] = "";
    			$users_dat['user_banned'] = 0;
    			$users_dat['user_bannedreason'] = "";
    			$users_dat['user_securekey'] = "";
    			$users_dat['user_regip'] = "::1";
    			$users_dat['user_editip'] = "::1";
    			$users[] = $users_dat;
    		}
    	}
    	else
    	{
    		$users = 0;
    	}

    	return $users;
    }

/**
 * function content
 * A function to get the the number of content pages from a Wordpress database
 * @author Philipp Louis Esselbach
 */

    function content()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(ID) FROM ".$preferences['acquire_db_prefix']."posts WHERE post_type = 'page'");
    	list($pages) = mysqli_fetch_row($query);

    	return $pages;
    }

/**
 * function contentpagesimport
 * A function to import content pages from a Wordpress database
 * @author Philipp Louis Esselbach
 */

    function contentpagesimport($start, $pages)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."posts WHERE post_type = 'page' LIMIT ".intval($start).", ".intval($pages));

    	if (mysqli_num_rows($query))
    	{
    		$contentpages = array();
    		while($contentpagesarray = mysqli_fetch_array($query))
    		{
    			$contentpages_dat = array();
    			$contentpages_dat['page_id'] = $contentpagesarray['ID'];

    			$query2 = mysqli_query($import_db_link,"SELECT user_name FROM ".$preferences['acquire_db_prefix']."users WHERE id = '".intval($contentpagesarray['post_author'])."'");
    			list($user_name) = mysqli_fetch_row($query2);
    			$contentpages_dat['page_author'] = $user_name;

    			$contentpages_dat['page_website'] = 0;
    			$contentpages_dat['page_title'] = $contentpagesarray['post_title'];
    			$contentpages_dat['page_text'] = $contentpagesarray['post_content'];
    			$contentpages_dat['page_html'] = 1;
    			$contentpages_dat['page_icon'] = 0;
    			$contentpages_dat['page_code'] = 0;
    			$contentpages_dat['page_postip'] = "::1";
    			$contentpages_dat['page_editip'] = "::1";
    			$contentpages[] = $contentpages_dat;
    		}
    	}
    	else
    	{
    		$contentpages = 0;
    	}

    	return $contentpages;
    }

/**
 * function newscategories
 * A function to get the the number of news categories from a Wordpress database
 * @author Philipp Louis Esselbach
 */

    function newscategories()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(term_id) FROM ".$preferences['acquire_db_prefix']."terms");
    	list($newscategories) = mysqli_fetch_row($query);

    	return $newscategories;
    }

/**
 * function newscategoriesimport
 * A function to import news categories from a Wordpress database
 * @author Philipp Louis Esselbach
 */

    function newscategoriesimport()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."terms");
    	if (mysqli_num_rows($query))
    	{
    		$newscategories = array();
    		while($newscategoriesarray = mysqli_fetch_array($query))
    		{
    			$newscategories_dat = array();
    			$newscategories_dat['category_id'] = $newscategoriesarray['term_id'];
    			$newscategories_dat['category_name'] = $newscategoriesarray['name'];
    			$newscategories_dat['category_desc'] = "";
    			$newscategories_dat['category_parent'] = "";
    			$newscategories_dat['category_permissions'] = "";
    			$newscategories_dat['category_postip'] = "::1";
    			$newscategories_dat['category_editip'] = "::1";
    			$newscategories[] = $newscategories_dat;
    		}
    	}
    	else
    	{
    		$newscategories = 0;
    	}

    	return $newscategories;
    }

/**
 * function newsstories
 * A function to get the the number of news stories from a Wordpress database
 * @author Philipp Louis Esselbach
 */

    function newsstories()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(ID) FROM ".$preferences['acquire_db_prefix']."posts WHERE post_type = 'post'");
    	list($newsstories) = mysqli_fetch_row($query);

    	return $newsstories;
    }

/**
 * function newsstoriesimport
 * A function to import news stories from a Wordpress database
 * @author Philipp Louis Esselbach
 */

    function newsstoriesimport($start, $stories)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."posts WHERE post_type = 'post' LIMIT ".intval($start).", ".intval($stories));

    	if (mysqli_num_rows($query))
    	{
    		$newsstories = array();
    		while($newsstoriesarray = mysqli_fetch_array($query))
    		{
    			$newsstories_dat = array();
    			$newsstories_dat['story_id'] = $newsstoriesarray['ID'];
    			$newsstories_dat['story_website'] = 0;
    			$newsstories_dat['story_category'] = $newsstoriesarray['post_category'];

    			$query2 = mysqli_query($import_db_link,"SELECT user_name FROM ".$preferences['acquire_db_prefix']."users WHERE id = '".intval($newsstoriesarray['post_author'])."'");
    			list($user_name) = mysqli_fetch_row($query2);
    			$newsstories_dat['story_author'] = $user_name;

    			$newsstories_dat['story_title'] = $newsstoriesarray['post_title'];
    			$newsstories_dat['story_text'] = $newsstoriesarray['post_content'];
    			$newsstories_dat['story_extendedtext'] = "";
    			$newsstories_dat['story_main'] = 1;
    			$newsstories_dat['story_time'] = $newsstoriesarray['post_date'];
    			$newsstories_dat['story_comments'] = $newsstoriesarray['comment_count'];
    			$newsstories_dat['story_source'] = "";
    			$newsstories_dat['story_teaser'] = "";
    			$newsstories_dat['story_extra1'] = "";
    			$newsstories_dat['story_extra2'] = "";
    			$newsstories_dat['story_extra3'] = "";
    			$newsstories_dat['story_extra4'] = "";
    			$newsstories_dat['story_extra5'] = "";
    			$newsstories_dat['story_extra6'] = "";
    			$newsstories_dat['story_extra7'] = "";
    			$newsstories_dat['story_extra8'] = "";
    			$newsstories_dat['story_extra9'] = "";
    			$newsstories_dat['story_extra10'] = "";
    			$newsstories_dat['story_extra11'] = "";
    			$newsstories_dat['story_extra12'] = "";
    			$newsstories_dat['story_extra13'] = "";
    			$newsstories_dat['story_extra14'] = "";
    			$newsstories_dat['story_extra15'] = "";
    			$newsstories_dat['story_extra16'] = "";
    			$newsstories_dat['story_extra17'] = "";
    			$newsstories_dat['story_extra18'] = "";
    			$newsstories_dat['story_extra19'] = "";
    			$newsstories_dat['story_extra20'] = "";
    			$newsstories_dat['story_html'] = 1;
    			$newsstories_dat['story_icon'] = 0;
    			$newsstories_dat['story_code'] = 0;
    			$newsstories_dat['story_postip'] = "::1";
    			$newsstories_dat['story_editip'] = "::1";
    			$newsstories_dat['story_editreason'] = "";
    			$newsstories_dat['story_hook'] = "0";
    			$newsstories_dat['story_sticky'] = "0";
    			$newsstories_dat['story_comm'] = "0";
    			$newsstories[] = $newsstories_dat;
    		}
    	}
    	else
    	{
    		$newsstories = 0;
    	}

    	return $newsstories;
    }

/**
 * function newsattachments
 * Dummy function to return zero news attachments
 * @author Philipp Louis Esselbach
 */
    function newsattachments()
    {
    	return 0;
    }

/**
 * function newscomments
 * A function to get the the number of news comments from a Wordpress database
 * @author Philipp Louis Esselbach
 */

    function newscomments()
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT COUNT(comment_ID) FROM ".$preferences['acquire_db_prefix']."comments");
    	list($newscomments) = mysqli_fetch_row($query);

    	return $newscomments;
    }

/**
 * function newscommentsimport
 * A function to import news comments from a Wordpress database
 * @author Philipp Louis Esselbach
 */

    function newscommentsimport($start, $comments)
    {
    	global $import_db_link, $preferences;

    	$query = mysqli_query($import_db_link,"SELECT * FROM ".$preferences['acquire_db_prefix']."comments LIMIT ".intval($start).", ".intval($comments));
    	if (mysqli_num_rows($query))
    	{
    		$newscomments = array();
    		while($newscommentsarray = mysqli_fetch_array($query))
    		{
    			$newscomments_dat = array();
    			$newscomments_dat['comment_id'] = $newscommentsarray['comment_ID'];
    			$newscomments_dat['comment_website'] = 0;
    			$newscomments_dat['comment_category'] = 1;
    			$newscomments_dat['comment_author'] = $newscommentsarray['comment_author'];
    			$newscomments_dat['comment_story'] = $newscommentsarray['comment_post_ID'];
    			$newscomments_dat['comment_icon'] = 1;
    			$newscomments_dat['comment_text'] = $newscommentsarray['comment_content'];
    			$newscomments_dat['comment_plonk'] = 0;
    			$newscomments_dat['comment_signature'] = 0;
    			$newscomments_dat['comment_smilies'] = 1;
    			$newscomments_dat['comment_bcode'] = 0;
    			$newscomments_dat['comment_time'] = $newscommentsarray['comment_date'];
    			$newscomments_dat['comment_postip'] = $newscommentsarray['comment_author_IP'];
    			$newscomments_dat['comment_editip'] = $newscommentsarray['comment_author_IP'];
    			$newscomments[] = $newscomments_dat;
    		}
    	}
    	else
    	{
    		$newscomments = 0;
    	}

    	return $newscomments;
    }

/**
 * function articlescategories
 * Dummy function to return zero article/review categories
 * @author Philipp Louis Esselbach
 */

    function articlescategories()
    {
    	return 0;
    }

/**
 * function articles
 * Dummy function to return zero article/review
 * @author Philipp Louis Esselbach
 */

    function articles()
    {
    	return 0;
    }

/**
 * function knowledgebasecategories
 * Dummy function to return zero knowledgebase/FAQ categories
 * @author Philipp Louis Esselbach
 */

    function knowledgebasecategories()
    {
    	return 0;
    }

/**
 * function knowledgebaseentries
 * Dummy function to return zero knowledgebase/FAQ entries
 * @author Philipp Louis Esselbach
 */

    function knowledgebaseentries()
    {
    	return 0;
    }

/**
 * function filescategories
 * Dummy function to return zero file categories
 * @author Philipp Louis Esselbach
 */

    function filescategories()
    {
    	return 0;
    }

/**
 * function files
 * Dummy function to return zero files
 * @author Philipp Louis Esselbach
 */

    function files()
    {
    	return 0;
    }

/**
 * function filescomments
 * Dummy function to return zero file comments
 * @author Philipp Louis Esselbach
 */

    function filescomments()
    {
    	return 0;
    }

/**
 * function glossary
 * Dummy function to return zero glossary entries
 * @author Philipp Louis Esselbach
 */

    function glossary()
    {
    	return 0;
    }
}

?>